<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.mulcan.common_features &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../" id="documentation_options" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/jquery.js"></script>
        <script src="../../../../_static/underscore.js"></script>
        <script src="../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../_static/doctools.js"></script>
    <script src="../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      <li>scripts.multiple_candidates.mulcan.common_features</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for scripts.multiple_candidates.mulcan.common_features</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module to find the shared features between multiples candidates.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">List</span><span class="p">,</span> <span class="n">Dict</span><span class="p">,</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Union</span>
<span class="kn">from</span> <span class="nn">itertools</span> <span class="kn">import</span> <span class="n">combinations</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">from</span> <span class="nn">scipy.special</span> <span class="kn">import</span> <span class="n">comb</span>

<span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="n">columns</span>
<span class="kn">from</span> <span class="nn">.</span> <span class="kn">import</span> <span class="n">events</span>


<span class="k">def</span> <span class="nf">_check_shared_features</span><span class="p">(</span>
    <span class="n">df_mult_repeated</span><span class="p">,</span>
    <span class="n">df_shared_feature_flags</span><span class="p">,</span>
    <span class="n">event_column</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span><span class="p">,</span>
    <span class="n">check_all_shared</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="n">list_features</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">drop_columns</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">list_subfeatures</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">verbose</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Check the combinations of two candidates of ``df_mult`` that either</span>

<span class="sd">    * share all the features (check whether there are identical events)</span>
<span class="sd">    * or does not share any of the features (check whether there share</span>
<span class="sd">        features that were not given)</span>

<span class="sd">    Args:</span>
<span class="sd">        df_mult: sample to check. Must already have the samples repeated</span>
<span class="sd">            and the column ``comb`` in order to group by events</span>
<span class="sd">            and combinations.</span>
<span class="sd">        df_shared_feature_flags: indices are ``event_column`` and the</span>
<span class="sd">            combination number ``comb``, and columns are the features given</span>
<span class="sd">            in ``list_features``. The values are booleans, and their values</span>
<span class="sd">            indicate wether the feature is shared between a combination</span>
<span class="sd">            of 2 candidates</span>
<span class="sd">        event_column: name of the column that allows to identify an event</span>
<span class="sd">        check_all_shared: whether to check events that share all the features,</span>
<span class="sd">            or events that does not share any of them</span>
<span class="sd">        list_features: list of the features</span>
<span class="sd">        drop_columns: columns to remove (because we are not interested</span>
<span class="sd">            in knowing whether there are shared or not)</span>
<span class="sd">        list_subfeatures: list of the subfeatures (i.e., all the</span>
<span class="sd">            columns the features defined in ``list_features`` are defined from)</span>
<span class="sd">        verbose: print the result of the check for each combination</span>
<span class="sd">            of 2 candidates (beware, it loops over the events)</span>

<span class="sd">    Returns:</span>
<span class="sd">        for the events in ``df_mult``, that share either all or</span>
<span class="sd">        None of the features, check whether the</span>
<span class="sd">        (other) columns are also shared / not shared</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">list_features</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">list_features</span> <span class="o">=</span> <span class="n">df_shared_feature_flags</span><span class="o">.</span><span class="n">keys</span><span class="p">()</span>

    <span class="c1"># Isolate the events that either share all of or None of the features</span>
    <span class="n">mask</span> <span class="o">=</span> <span class="kc">True</span>
    <span class="k">for</span> <span class="n">feature</span> <span class="ow">in</span> <span class="n">list_features</span><span class="p">:</span>
        <span class="n">mask</span> <span class="o">&amp;=</span> <span class="p">(</span>
            <span class="n">df_shared_feature_flags</span><span class="p">[</span><span class="n">feature</span><span class="p">]</span> <span class="o">==</span> <span class="n">check_all_shared</span>
        <span class="p">)</span>
    <span class="n">df_shared_feature_flags_masked</span> <span class="o">=</span> <span class="n">df_shared_feature_flags</span><span class="p">[</span><span class="n">mask</span><span class="p">]</span>

    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">df_shared_feature_flags_masked</span><span class="p">)</span> <span class="o">&gt;=</span> <span class="mi">1</span><span class="p">:</span>
        <span class="c1"># Filter the main sample using these events</span>
        <span class="n">df_mult_repeated_masked</span> <span class="o">=</span> <span class="n">df_mult_repeated</span><span class="o">.</span><span class="n">set_index</span><span class="p">(</span>
            <span class="p">[</span><span class="n">event_column</span><span class="p">,</span> <span class="s2">&quot;comb&quot;</span><span class="p">]</span>
        <span class="p">)</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">df_shared_feature_flags_masked</span><span class="o">.</span><span class="n">index</span><span class="p">]</span>

        <span class="c1"># Drop undesirable columns</span>
        <span class="k">if</span> <span class="p">((</span><span class="n">check_all_shared</span> <span class="ow">and</span> <span class="n">list_subfeatures</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">)</span>
                <span class="ow">or</span> <span class="n">drop_columns</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">):</span>

            <span class="c1"># No need to include the features since there are completely</span>
            <span class="c1"># shared anyway so we&#39;ll have many ``True`` values</span>
            <span class="k">if</span> <span class="n">check_all_shared</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">drop_columns</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">drop_columns</span> <span class="o">=</span> <span class="p">[]</span>

                <span class="n">drop_columns</span> <span class="o">=</span> <span class="n">drop_columns</span> <span class="o">+</span> <span class="n">list_subfeatures</span>

            <span class="n">df_mult_repeated_masked</span><span class="o">.</span><span class="n">drop</span><span class="p">(</span>
                <span class="n">columns</span><span class="o">=</span><span class="n">drop_columns</span><span class="p">,</span> <span class="n">errors</span><span class="o">=</span><span class="s1">&#39;ignore&#39;</span><span class="p">,</span>
                <span class="n">inplace</span><span class="o">=</span><span class="kc">True</span>
            <span class="p">)</span>

        <span class="c1"># Group the filtered sample by events and combinations (again)</span>
        <span class="n">df_mult_repeated_masked_grouped</span> <span class="o">=</span> <span class="n">df_mult_repeated_masked</span><span class="o">.</span><span class="n">groupby</span><span class="p">(</span>
            <span class="p">[</span><span class="n">event_column</span><span class="p">,</span> <span class="s2">&quot;comb&quot;</span><span class="p">],</span> <span class="n">sort</span><span class="o">=</span><span class="kc">False</span>
        <span class="p">)</span>

        <span class="k">if</span> <span class="n">check_all_shared</span><span class="p">:</span>
            <span class="c1"># (only one value means there are shared)</span>
            <span class="n">df_mult_masked_shared_flags</span> <span class="o">=</span> <span class="p">(</span>
                <span class="n">df_mult_repeated_masked_grouped</span><span class="o">.</span><span class="n">nunique</span><span class="p">()</span> <span class="o">==</span> <span class="mi">1</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">df_mult_masked_shared_flags</span> <span class="o">=</span> <span class="p">(</span>
                <span class="n">df_mult_repeated_masked_grouped</span><span class="o">.</span><span class="n">nunique</span><span class="p">()</span> <span class="o">==</span> <span class="mi">2</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">check_all_shared</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Combinations of two candidates &quot;</span>
                      <span class="s2">&quot;that shared all the features that were given&quot;</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Combinations of two candidates &quot;</span>
                      <span class="s2">&quot;that did not share any features that were given&quot;</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">row</span> <span class="ow">in</span> <span class="n">df_mult_masked_shared_flags</span><span class="o">.</span><span class="n">iterrows</span><span class="p">():</span>
                <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Event:&quot;</span><span class="p">,</span> <span class="n">index</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="s2">&quot; and combination&quot;</span><span class="p">,</span> <span class="n">index</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
                <span class="k">if</span> <span class="n">check_all_shared</span><span class="p">:</span>
                    <span class="k">if</span> <span class="n">row</span><span class="o">.</span><span class="n">sum</span><span class="p">():</span>

                        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;The two candidates are identical.&quot;</span><span class="p">)</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">list_diff_columns</span> <span class="o">=</span> <span class="p">[]</span>
                        <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">row</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
                            <span class="k">if</span> <span class="ow">not</span> <span class="n">row</span><span class="p">[</span><span class="n">column</span><span class="p">]:</span>
                                <span class="n">list_diff_columns</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">column</span><span class="p">)</span>
                        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Columns that are different:&quot;</span><span class="p">,</span>
                              <span class="n">list_diff_columns</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="k">if</span> <span class="ow">not</span> <span class="n">row</span><span class="o">.</span><span class="n">sum</span><span class="p">():</span>
                        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;The two candidates are completely different.&quot;</span><span class="p">)</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">list_diff_columns</span> <span class="o">=</span> <span class="p">[]</span>
                        <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">row</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
                            <span class="k">if</span> <span class="ow">not</span> <span class="n">row</span><span class="p">[</span><span class="n">column</span><span class="p">]:</span>
                                <span class="n">list_diff_columns</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">column</span><span class="p">)</span>
                        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Columns that are the same:&quot;</span><span class="p">,</span>
                              <span class="n">list_diff_columns</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">df_mult_masked_shared_flags</span>

    <span class="k">elif</span> <span class="n">verbose</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">check_all_shared</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;The sample has no events that share all the features&quot;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;The sample has no events &quot;</span>
                  <span class="s2">&quot;that does not share any of the features&quot;</span>
                  <span class="p">)</span>


<div class="viewcode-block" id="get_index_combination"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.common_features.get_index_combination">[docs]</a><span class="k">def</span> <span class="nf">get_index_combination</span><span class="p">(</span><span class="n">mult</span><span class="p">:</span> <span class="nb">int</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Compute the combination numbers to assign to each candidate.</span>

<span class="sd">    Args:</span>
<span class="sd">        mult: candidate multiplicity</span>

<span class="sd">    Returns:</span>
<span class="sd">        Associates a two-dimensional array, with one row for each of the</span>
<span class="sd">        ``mult`` candidate multiplicty, and one column for each copy of</span>
<span class="sd">        the ``mult - 1`` copies of the  candidates.</span>

<span class="sd">    Notes:</span>
<span class="sd">        Say we want to find all the possible combinations of ``mult``</span>
<span class="sd">        candidates in a vectorised way.</span>

<span class="sd">        What we can do is define a variable ``comb`` which is an index of</span>
<span class="sd">        the `2 choose mult` possible combinations. Thus, ``comb``</span>
<span class="sd">        is an integer ranging from 1 to ``comb``.</span>

<span class="sd">        Then, we will use ``groupby`` on ``comb`` in order to gather the</span>
<span class="sd">        candidates with the same value of ``comb`` together. Since we need</span>
<span class="sd">        ``2 choose comb`` combinations, we need ``2 * (`2 choose comb`)``</span>
<span class="sd">        candidates, and we already have ``comb`` candidates.</span>
<span class="sd">        We thus need to duplicate the sample</span>
<span class="sd">        ``2 * (`2 choose comb`) / comb = comb - 1`` times only.</span>

<span class="sd">        For instance, for ``mult = 3`` (3 candidates), there are 3 possible</span>
<span class="sd">        combinations.</span>
<span class="sd">        ``comb = 1`` corresponds to the combination of the 1st candidate with</span>
<span class="sd">        the 2nd one, ``comb = 2``, is the combination of the 1st candidate</span>
<span class="sd">        and the 3rd candidate, Finally ``comb = 3`` corresponds to the last</span>
<span class="sd">        combination of the 2nd or the 3rd candidate. We well also need</span>
<span class="sd">        to duplicate the sample ``mult - 1 = 2`` times (so just the original</span>
<span class="sd">        and 1 copy).</span>

<span class="sd">        It is hightly possible there is a less weird way to do this ...</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1">#: Number of combinations, which is just given by a binomial coefficient</span>
    <span class="n">nb_comb</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">comb</span><span class="p">(</span><span class="n">mult</span><span class="p">,</span> <span class="mi">2</span><span class="p">))</span>

    <span class="c1">#: A row of ``comb_indices`` corresponds to one combination, and</span>
    <span class="c1">#: a column corresponds to one of the ``mult`` candidates.</span>
    <span class="c1">#: Finally, the value is zero or one, which corresponds to whether or not</span>
    <span class="c1">#: the candidate is taken to form the combination</span>
    <span class="n">comb_mask</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(</span><span class="n">nb_comb</span><span class="p">,</span> <span class="n">mult</span><span class="p">),</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">int</span><span class="p">)</span>
    <span class="c1"># We will remove the 0 later on in order to keep only the ``mult - 1``</span>
    <span class="c1"># needed copies</span>

    <span class="c1"># Find the indices to which we will assign `1`</span>
    <span class="n">indx</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">indy</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">id_comb</span><span class="p">,</span> <span class="n">combination</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span>
        <span class="n">combinations</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="n">mult</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">int</span><span class="p">),</span> <span class="mi">2</span><span class="p">)</span>
    <span class="p">):</span>
        <span class="n">indx</span> <span class="o">+=</span> <span class="p">[</span><span class="n">id_comb</span><span class="p">,</span> <span class="n">id_comb</span><span class="p">]</span>
        <span class="n">indy</span> <span class="o">+=</span> <span class="nb">list</span><span class="p">(</span><span class="n">combination</span><span class="p">)</span>
    <span class="n">indxy</span> <span class="o">=</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">asarray</span><span class="p">(</span><span class="n">indx</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">asarray</span><span class="p">(</span><span class="n">indy</span><span class="p">))</span>
    <span class="n">comb_mask</span><span class="p">[</span><span class="n">indxy</span><span class="p">]</span> <span class="o">=</span> <span class="mi">1</span>

    <span class="c1"># Now, we multiply each of the row by its index (from 1 to `2 choose mult`)</span>
    <span class="c1"># to distinguish each combination using an integer</span>
    <span class="n">comb_indices</span> <span class="o">=</span> <span class="n">comb_mask</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span>
        <span class="mi">1</span><span class="p">,</span> <span class="n">nb_comb</span> <span class="o">+</span> <span class="mi">1</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">int</span>
    <span class="p">)[:,</span> <span class="n">np</span><span class="o">.</span><span class="n">newaxis</span><span class="p">]</span>
    <span class="c1"># One column of this array without the zeros corresponds to the ``comb``</span>
    <span class="c1"># values to assign to each of the ``mult - 1`` copy of the candidates.</span>
    <span class="c1"># Thus, we just need to remove the zeros from ``comb_indices``</span>
    <span class="c1"># (which we do in a strange way, but it does work)</span>
    <span class="k">return</span> <span class="n">comb_indices</span><span class="o">.</span><span class="n">T</span><span class="p">[</span><span class="n">comb_indices</span><span class="o">.</span><span class="n">T</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">mult</span><span class="p">,</span> <span class="n">mult</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span></div>


<div class="viewcode-block" id="find_shared_features_given_mult"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.common_features.find_shared_features_given_mult">[docs]</a><span class="k">def</span> <span class="nf">find_shared_features_given_mult</span><span class="p">(</span>
    <span class="n">dataframe</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span>
    <span class="n">series_event_mults</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">,</span>
    <span class="n">mult</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span>
    <span class="n">dict_features</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]],</span>
    <span class="n">event_column</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span><span class="p">,</span>
    <span class="n">event_columns</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMNS</span><span class="p">,</span>
    <span class="n">check_all_shared</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="n">check_nothing_shared</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Find the shared features of a dataframe, for a given multiplicity</span>
<span class="sd">    ``mult``.</span>

<span class="sd">    Args:</span>
<span class="sd">        dataframe: full sample</span>
<span class="sd">        series_event_mults: Indices are the event numbers, and values are</span>
<span class="sd">            the associated number of candidates. OR can also be a dictionnary</span>
<span class="sd">            that associates a multiplicity with the list of events.</span>
<span class="sd">            (This is ugly but practical just to assure that the code</span>
<span class="sd">            works both in the notebook and python script.)</span>
<span class="sd">        mult: candidate multiplicity of each event</span>
<span class="sd">        dict_features: associates a name of features with a column, or a</span>
<span class="sd">            list a columns that must be all equal, for 2 candidates</span>
<span class="sd">            to be declared to share the same features</span>
<span class="sd">        event_column: name of the column that allows to identify an event</span>
<span class="sd">        event_columns: list of columns ``event_column`` corresponds to</span>
<span class="sd">        check_all_shared : individually check the events that share all</span>
<span class="sd">            the features given in ``dict_features``</span>
<span class="sd">        check_nothing_shared: individually check the events that share all</span>
<span class="sd">            the features given in ``dict_features``</span>

<span class="sd">    Returns:</span>
<span class="sd">        indices are ``event_column`` and the combination number ``comb``,</span>
<span class="sd">        and columns are the features given in ``dict_features``.</span>
<span class="sd">        The values are booleans, and their values indicate whether</span>
<span class="sd">        the feature is shared between a combination of 2 candidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Isolate the multiple candidates with multiplicity = mult</span>
    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">series_event_mults</span><span class="p">,</span> <span class="nb">dict</span><span class="p">):</span>
        <span class="k">assert</span> <span class="n">mult</span> <span class="ow">in</span> <span class="n">series_event_mults</span>
        <span class="n">df_mult</span> <span class="o">=</span> <span class="n">dataframe</span><span class="p">[</span>
            <span class="n">dataframe</span><span class="p">[</span><span class="n">event_column</span><span class="p">]</span><span class="o">.</span><span class="n">isin</span><span class="p">(</span><span class="n">series_event_mults</span><span class="p">[</span><span class="n">mult</span><span class="p">])</span>
        <span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">df_mult</span> <span class="o">=</span> <span class="n">events</span><span class="o">.</span><span class="n">get_dataframe_with_given_mult</span><span class="p">(</span>
            <span class="n">dataframe</span><span class="p">,</span> <span class="n">series_event_mults</span><span class="p">,</span> <span class="n">event_column</span><span class="p">,</span> <span class="n">mult</span>
        <span class="p">)</span>

    <span class="c1"># Sort to form the groups</span>
    <span class="n">df_mult</span><span class="o">.</span><span class="n">sort_values</span><span class="p">(</span><span class="n">event_columns</span><span class="p">)</span><span class="o">.</span><span class="n">reset_index</span><span class="p">(</span><span class="n">inplace</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

    <span class="c1"># To form groups of 2 candidates for each candidate,</span>
    <span class="c1"># we need ``mult - 1`` copies of each event</span>
    <span class="c1"># (note that the repeated candidates are next to each other)</span>
    <span class="c1"># in the dataframe</span>
    <span class="n">df_mult_repeated</span> <span class="o">=</span> <span class="n">df_mult</span><span class="o">.</span><span class="n">iloc</span><span class="p">[</span>
        <span class="n">np</span><span class="o">.</span><span class="n">repeat</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">df_mult</span><span class="p">)),</span> <span class="n">mult</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span>
    <span class="p">]</span>
    <span class="c1"># In order to compare the candidates in twos,</span>
    <span class="c1"># we want to group them (`groupby`) by combinations of 2 candidates,</span>
    <span class="c1"># for each event.</span>
    <span class="c1"># Thus we need to create a new column ``comb``. 2 candidates of an event</span>
    <span class="c1"># that have the same ``comb`` value will belong to the same combination.</span>
    <span class="c1"># The integer ``comb`` ranges from 1 to the number of</span>
    <span class="c1"># possible combinations `2 choose comb`.</span>
    <span class="n">df_mult_repeated</span><span class="o">.</span><span class="n">loc</span><span class="p">[:,</span> <span class="s2">&quot;comb&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">tile</span><span class="p">(</span>
        <span class="n">get_index_combination</span><span class="p">(</span><span class="n">mult</span><span class="p">)</span><span class="o">.</span><span class="n">flatten</span><span class="p">(),</span>
        <span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">df_mult</span><span class="p">)</span> <span class="o">/</span> <span class="n">mult</span><span class="p">)</span>
    <span class="p">)</span>

    <span class="c1"># Group by events and combination</span>
    <span class="n">df_grouped</span> <span class="o">=</span> <span class="n">df_mult_repeated</span><span class="o">.</span><span class="n">groupby</span><span class="p">([</span><span class="n">event_column</span><span class="p">,</span> <span class="s2">&quot;comb&quot;</span><span class="p">],</span> <span class="n">sort</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

    <span class="n">list_shared_feature_flags</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">feature</span><span class="p">,</span> <span class="n">list_columns</span> <span class="ow">in</span> <span class="n">dict_features</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
        <span class="n">list_shared_feature_flags</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
            <span class="n">df_grouped</span><span class="p">[</span><span class="n">list_columns</span><span class="p">]</span>
            <span class="o">.</span><span class="n">nunique</span><span class="p">()</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">eq</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">list_columns</span><span class="p">))</span><span class="o">.</span><span class="n">rename</span><span class="p">(</span><span class="n">feature</span><span class="p">)</span>
        <span class="p">)</span>
    <span class="n">df_shared_feature_flags</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">concat</span><span class="p">(</span>
        <span class="n">list_shared_feature_flags</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span>
    <span class="p">)</span>

    <span class="c1"># Checks</span>
    <span class="n">list_subfeatures</span> <span class="o">=</span> <span class="p">[</span><span class="n">element</span>
                        <span class="k">for</span> <span class="n">list_features</span> <span class="ow">in</span> <span class="n">dict_features</span><span class="o">.</span><span class="n">values</span><span class="p">()</span>
                        <span class="k">for</span> <span class="n">element</span> <span class="ow">in</span> <span class="n">list_features</span>
                        <span class="p">]</span>
    <span class="n">list_checks_all_shared</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">if</span> <span class="n">check_all_shared</span><span class="p">:</span>
        <span class="n">list_checks_all_shared</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="kc">True</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">check_nothing_shared</span><span class="p">:</span>
        <span class="n">list_checks_all_shared</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="kc">False</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">check_all_shared</span> <span class="ow">in</span> <span class="n">list_checks_all_shared</span><span class="p">:</span>
        <span class="n">_</span> <span class="o">=</span> <span class="n">_check_shared_features</span><span class="p">(</span>
            <span class="n">df_mult_repeated</span><span class="p">,</span>
            <span class="n">df_shared_feature_flags</span><span class="p">,</span>
            <span class="n">event_column</span><span class="o">=</span><span class="n">event_column</span><span class="p">,</span>
            <span class="n">check_all_shared</span><span class="o">=</span><span class="n">check_all_shared</span><span class="p">,</span>
            <span class="n">drop_columns</span><span class="o">=</span><span class="n">columns</span><span class="o">.</span><span class="n">LIST_EQUAL_COLUMNS_DEFAULT</span><span class="p">,</span>
            <span class="n">list_subfeatures</span><span class="o">=</span><span class="n">list_subfeatures</span>
        <span class="p">)</span>

    <span class="k">return</span> <span class="n">df_shared_feature_flags</span></div>


<div class="viewcode-block" id="array_feature_flags_into_features"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.common_features.array_feature_flags_into_features">[docs]</a><span class="k">def</span> <span class="nf">array_feature_flags_into_features</span><span class="p">(</span>
    <span class="n">array_possible_feature_flags</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span>
    <span class="n">list_features</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Convert the array of array of booleans, each boolean corresponding to</span>
<span class="sd">    a flag to tell if the feature is shared or not, into a list of list</span>
<span class="sd">    of the features that are shared.</span>

<span class="sd">    Args:</span>
<span class="sd">        array_shared_features: array of an array of booleans,</span>
<span class="sd">            each boolean corresponding to one of the feature. Thus, one row of</span>
<span class="sd">            this array corresponds to a possible set of common features,</span>
<span class="sd">            encoded by an array of booleans.</span>
<span class="sd">        list_features: list of the name of the features corresponding to</span>
<span class="sd">            the columns of ``array_shared_features``</span>

<span class="sd">    Returns:</span>
<span class="sd">        list of list of features that were flagged in ``array_shared_features``</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">list_possible_shared_features</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">list_feature_flags</span> <span class="ow">in</span> <span class="n">array_possible_feature_flags</span><span class="p">:</span>
        <span class="n">list_shared_features</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">feature_index</span><span class="p">,</span> <span class="n">feature_flag</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">list_feature_flags</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">feature_flag</span><span class="p">:</span>
                <span class="n">list_shared_features</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">list_features</span><span class="p">[</span><span class="n">feature_index</span><span class="p">])</span>
        <span class="n">list_possible_shared_features</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">list_shared_features</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">list_possible_shared_features</span></div>


<div class="viewcode-block" id="count_shared_features"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.common_features.count_shared_features">[docs]</a><span class="k">def</span> <span class="nf">count_shared_features</span><span class="p">(</span>
    <span class="n">df_shared_feature_flags</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span>
    <span class="n">list_features</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">sort</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">bool</span><span class="p">]</span> <span class="o">=</span> <span class="kc">True</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Union</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot; Get the possible shared features between multiple candidates,</span>
<span class="sd">    and their yields.</span>

<span class="sd">    Args:</span>
<span class="sd">        df_shared_feature_flags: indices are ``event_column`` and the</span>
<span class="sd">            combination number ``comb``, and columns are the features given</span>
<span class="sd">            in ``dict_features``. The values are booleans, and their values</span>
<span class="sd">            indicate wether the feature is shared between a combination</span>
<span class="sd">            of 2 candidates</span>
<span class="sd">        features: list of features. If not given, directly taken as the</span>
<span class="sd">            columns of ``df_shared_feature_flags``</span>
<span class="sd">        sort: whether to sort the shared features by the number</span>
<span class="sd">            that was found.</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * list_possible_shared_features: possible list of features that \</span>
<span class="sd">        are simultaneously shared by the combination of 2 features</span>
<span class="sd">        * array_shared_feature_yields: corresponding yields (aka number \</span>
<span class="sd">        of combinations that were observed)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">list_features</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">list_features</span> <span class="o">=</span> <span class="n">df_shared_feature_flags</span><span class="o">.</span><span class="n">keys</span><span class="p">()</span>

    <span class="n">array_shared_features</span><span class="p">,</span> <span class="n">array_shared_feature_yields</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">unique</span><span class="p">(</span>
        <span class="n">df_shared_feature_flags</span><span class="p">[</span><span class="n">list_features</span><span class="p">],</span>
        <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">return_counts</span><span class="o">=</span><span class="kc">True</span>
    <span class="p">)</span>
    <span class="c1"># array_shared_features is an array of an array of booleans,</span>
    <span class="c1"># each boolean corresponding to one of the feature. Thus, one row of</span>
    <span class="c1"># this array corresponds to a possible set of common features,</span>
    <span class="c1"># encoded by an array of booleans.</span>

    <span class="k">if</span> <span class="n">sort</span><span class="p">:</span>
        <span class="c1"># Sorting</span>
        <span class="n">sorting_indices</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">argsort</span><span class="p">(</span><span class="n">array_shared_feature_yields</span><span class="p">)</span>
        <span class="n">array_shared_feature_yields</span> <span class="o">=</span> <span class="n">array_shared_feature_yields</span><span class="p">[</span>
            <span class="n">sorting_indices</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
        <span class="p">]</span>
        <span class="n">array_shared_features</span> <span class="o">=</span> <span class="n">array_shared_features</span><span class="p">[</span>
            <span class="n">sorting_indices</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
        <span class="p">]</span>

    <span class="n">list_possible_shared_features</span> <span class="o">=</span> <span class="n">array_feature_flags_into_features</span><span class="p">(</span>
        <span class="n">array_shared_features</span><span class="p">,</span>
        <span class="n">list_features</span>
    <span class="p">)</span>
    <span class="k">return</span> <span class="n">list_possible_shared_features</span><span class="p">,</span> <span class="n">array_shared_feature_yields</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>